=== debian/changelog ===
memtest86+ (8.00-3) unstable; urgency=medium

  * Really fix copying mt86+x64 file for systemd-boot. (Closes: #1121485)

 -- Felix Zielcke <fzielcke@z-51.de>  Sat, 29 Nov 2025 09:22:20 +0100

memtest86+ (8.00-2) unstable; urgency=medium

  * Fix postinst systemd configuration to use the new combined image
    file without .efi extension. (Closes: #1121485)
  * Update d/copyright.

 -- Felix Zielcke <fzielcke@z-51.de>  Fri, 28 Nov 2025 18:01:09 +0100

memtest86+ (8.00-1) unstable; urgency=medium

  * New upstream version.
  * Update Standards-Version to 4.7.2.
  * Update d/watch to version 5.

 -- Felix Zielcke <fzielcke@z-51.de>  Mon, 24 Nov 2025 16:29:34 +0100
