=== debian/control ===
Source: memtest86+
Section: misc
Priority: optional
Maintainer: Fabio Fantoni <fantonifabio@tiscali.it>
Uploaders: Felix Zielcke <fzielcke@z-51.de>
Build-Depends:
 debhelper-compat (= 13),
 dh-exec,
 dosfstools,
 gcc-multilib [!hurd-any !kfreebsd-any],
 mtools,
 xorriso,
Homepage: https://www.memtest.org/
Vcs-Git: https://salsa.debian.org/debian/memtest86plus.git
Vcs-Browser: https://salsa.debian.org/debian/memtest86plus
Standards-Version: 4.7.2
Rules-Requires-Root: no

Package: memtest86+
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386
Depends: grub-common, ${misc:Depends}
Suggests: grub-efi | grub-pc, memtester, mtools
Description: stand-alone memory tester for x86 and x86-64
 Memtest86+ provides a more thorough memory check than
 that provided by BIOS memory tests. Can be loaded and run either
 directly by a PC BIOS (legacy or UEFI) or via an intermediate
 bootloader.
 .
 This tester runs independently of any OS - it is run at computer
 boot-up, so that it can test *all* of your memory.  You may want to
 look at `memtester', which allows one to test your memory within Linux,
 but this one won't be able to test your whole RAM.
 .
 It can output a list of bad RAM regions usable by the BadRAM kernel
 patch, so that you can still use your old RAM with one or two bad bits.
